#include <bits/stdc++.h>

using namespace std;

long long a[1000000],a2[1000000];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    long long n,h;
    cin>>h>>n;
    for(long long j=0;j<n;j++)
    {a[j]=1;a2[j]=1;}
    for(long long i=0;i<h;i++)
    {
        for(long long j=0;j<n;j++)
            cin>>a[j];
        for(long long j=0;j<n;j++)
            if(j==0)
            {
                if(a[j]==0)
                {
                    bool desno=false;
                    long long k=0;
                    while(desno==false)
                    {
                        if(a[k+1]==1)
                        {
                            desno=true;
                        }
                        else
                        {
                            k++;
                        }
                    }
                    a2[k+1]+=a2[j];
                    a2[j]=0;
                }
            }
            else if(j==n-1)
            {
                if(a[j]==0)
                {
                    bool levo=false;
                    long long k=n-1;
                    while(levo==false)
                    {
                        if(a[k-1]==1)
                        {
                            levo=true;
                        }
                        else
                        {
                            k--;
                        }
                    }
                    a2[k-1]+=a2[j];
                    a2[j]=0;
                }
            }
            else
            {
                if(a[j]==0)
                {
                    bool desno=false,levo=false;
                    long long kl=j,kd=j;
                    while(desno==false)
                    {
                        if(kd==n-1)
                            break;
                        else if(a[kd+1]==1)
                        {
                            desno=true;
                        }
                        else
                        {
                            kd++;
                        }
                    }
                    while(levo==false)
                    {
                        if(kl==0)
                            break;
                        else if(a[kl-1]==1)
                        {
                            levo=true;
                        }
                        else
                        {
                            kl--;
                        }
                    }
                    if(levo==false)
                    {
                        a2[kd+1]+=a2[j];
                        a2[j]=0;
                    }
                    else if(desno==false)
                    {
                        a2[kl-1]+=a2[j];
                        a2[j]=0;
                    }
                    else
                    {
                        if(a2[j]%2==1)
                            {
                                if(i%2==0)
                                    a2[kl-1]++;
                                else
                                    a2[kd+1]++;
                                a2[j]--;
                            }
                        a2[kl-1]+=a2[j]/2;
                        a2[kd+1]+=a2[j]/2;
                        a2[j]=0;
                    }

                }
            }
        }
    for(long long i=0;i<n;i++)
        cout<<a2[i]<<" ";
}